<script lang="ts">
import Vue from 'vue';
import ParallaxContainer from '../2023/parallax-container.vue';
import FloatingOrbs from './floating-orbs.vue';
import Globe from './globe.vue';
import RedGreenCurves from './red-green-curves.vue';
import YellowPurpleDashedCurves from './yellow-purple-dashed-curves.vue';
import DashedCurves from './dashed-curves.vue';
import PurpleLoops from './purple-loops.vue';

export default Vue.extend({
  name: 'HeroAnimation',
  components: {
    Globe,
    RedGreenCurves,
    YellowPurpleDashedCurves,
    DashedCurves,
    PurpleLoops,
    ParallaxContainer,
    FloatingOrbs,
  },

  methods: {},
});
</script>

<template>
  <div class="hero-animation">
    <div class="glow">
      <div></div>
      <div></div>
    </div>
    <div class="hero-animation--animate-in">
      <Globe class="hero-animation__globe" />
      <RedGreenCurves />
      <YellowPurpleDashedCurves />
      <DashedCurves />
      <PurpleLoops />
      <div class="hero-animation__orbs">
        <ParallaxContainer>
          <FloatingOrbs />
        </ParallaxContainer>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.hero-animation {
  position: relative;
  width: 85%;
  margin: 0 auto;
  @media (min-width: $breakpoint-md) {
    width: 100%;
  }
  &__orbs {
    position: absolute;
    top: -26%;
    left: -5%;
    width: 114%;
    :deep svg {
      width: 100%;
    }
  }
  &__globe {
    width: 63%;
  }
  &--animate-in {
    opacity: 0;
    animation: animate-in 0.9s linear forwards 1s;
  }
  .glow {
    mix-blend-mode: screen;
    top: 0;
    left: 0%;
    position: absolute;
    width: 107.2%;
    height: 107.2%;
    backface-visibility: hidden;
    perspective: 1000;
    will-change: transform, opacity;
    animation: glow 1s linear forwards 1.5s;
    opacity: 0;
    transform: scale3d(0.8, 0.8, 1);
    &:before {
      content: '';
      position: absolute;
      width: 47%;
      left: 0;
      top: 14%;
      padding-bottom: 47%;
      border-radius: 50%;
      background: radial-gradient(
        46.23% 46.23% at 50.01% 49.99%,
        #67d2ba 0%,
        #50a390 14%,
        #33695d 34%,
        #1d3c35 52%,
        #0d1b18 68%,
        #030706 81%,
        #000000 90%
      );
      background-blend-mode: screen;
      mix-blend-mode: screen;
    }
    &:after {
      content: '';
      top: -22%;
      left: 25%;
      position: absolute;
      width: 47%;
      padding-bottom: 47%;

      border-radius: 50%;
      background: radial-gradient(
        46.02% 46.02% at 48.9% 50.26%,
        #a989f5 0%,
        #a183ea 3%,
        #715ba4 22%,
        #483b69 39%,
        #29213c 56%,
        #120f1b 70%,
        #040407 82%,
        #000000 90%
      );
      background-blend-mode: screen;
      mix-blend-mode: screen;
    }
    & > :nth-child(1) {
      position: absolute;
      width: 44%;
      padding-bottom: 44%;

      border-radius: 50%;
      top: 0%;
      right: 10%;
      background: radial-gradient(
        46.15% 46.15% at 50.02% 49.99%,
        #ffd58c 0%,
        #eac380 5%,
        #a4895a 23%,
        #69583a 41%,
        #3c3220 57%,
        #1b160e 71%,
        #070603 82%,
        #000000 90%
      );
      background-blend-mode: screen;
      mix-blend-mode: screen;
    }
    & > :nth-child(2) {
      position: absolute;
      width: 44%;
      padding-bottom: 44%;

      border-radius: 50%;
      bottom: -10%;
      right: 30%;
      background: radial-gradient(
        46.15% 46.15% at 50.02% 50%,
        #e24329 0%,
        #a3301d 18%,
        #691f13 37%,
        #3c110a 54%,
        #1b0804 69%,
        #070201 82%,
        #000000 90%
      );
      background-blend-mode: screen;
      mix-blend-mode: screen;
    }
  }

  @keyframes glow {
    to {
      opacity: 0.5;
      transform: scale3d(1, 1, 1);
    }
  }
  @keyframes animate-in {
    from {
      opacity: 0;
    }
    to {
      opacity: 1;
    }
  }
}
</style>
